﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class CompareByColor : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xShip = x as DrawingObjectShip;
            var yShip = y as DrawingObjectShip;
            var rgbCompareR = xShip.GetShip.Ship.BodyColor.R.CompareTo(yShip.GetShip.Ship.BodyColor.R);
            if (rgbCompareR != 0)
            {
                return rgbCompareR;
            }
            var rgbCompareG = xShip.GetShip.Ship.BodyColor.G.CompareTo(yShip.GetShip.Ship.BodyColor.G);
            if (rgbCompareG != 0)
            {
                return rgbCompareG;
            }
            var rgbCompareB = xShip.GetShip.Ship.BodyColor.B.CompareTo(yShip.GetShip.Ship.BodyColor.B);
            if (rgbCompareB != 0)
            {
                return rgbCompareB;
            }
            if (xShip.GetShip.Ship is EntityContainerShip xContainerShip && yShip.GetShip.Ship is EntityContainerShip yContainerShip)
            {
                var rgbDopCompareR = xContainerShip.DopColor.R.CompareTo(yContainerShip.DopColor.R);
                if (rgbDopCompareR != 0)
                {
                    return rgbDopCompareR;
                }
                var rgbDopCompareB = xContainerShip.DopColor.G.CompareTo(yContainerShip.DopColor.G);
                if (rgbDopCompareB != 0)
                {
                    return rgbDopCompareB;
                }
                var rgbDopCompareG = xContainerShip.DopColor.B.CompareTo(yContainerShip.DopColor.B);
                if (rgbDopCompareG != 0)
                {
                    return rgbDopCompareG;
                }
                return 0;
            }
            return 0;
        }
    }
}

