﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class CompareByType: IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xShip = x as DrawingObjectShip;
            var yShip = y as DrawingObjectShip;
            if (xShip == null && yShip == null)
            {
                return 0;
            }
            if (xShip == null && yShip != null)
            {
                return 1;
            }
            if (xShip != null && yShip == null)
            {
                return -1;
            }
            if (xShip.GetShip.GetType().Name != yShip.GetShip.GetType().Name)
            {
                if (xShip.GetShip.GetType().Name == "DrawingShip")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xShip.GetShip.Ship.Speed.CompareTo(yShip.GetShip.Ship.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xShip.GetShip.Ship.Weight.CompareTo(yShip.GetShip.Ship.Weight);
        }
    }
}
