﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class EntityContainerShip : EntityShip
    {
        public Color DopColor { get; private set; }
        public bool Containers { get; private set; }
        public bool Crane { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="wing">Признак наличия антикрыла</param>
        /// <param name="sportLine">Признак наличия гоночной полосы</param>
        public EntityContainerShip(int speed, float weight, Color bodyColor, Color dopColor, bool crane, bool containers) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            Crane = crane;
            Containers = containers;
        }

        public void setDopColor(Color newDopColor) 
        { 
            DopColor = newDopColor; 
        }
    }
}
